SystemOrganization addCategory: #'Spec-Tests'!

ComposableModel subclass: #TestingComposableModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!TestingComposableModel commentStamp: '<historical>' prior: 0!
A TestingComposableModel is a stupid composable model used to test SpecInterpreter!

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 3/2/2012 06:16'!
internSpec
	<spec>
	^ {#List.
		#model:.	#model.}! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 17:35'!
testingSpec

	^ {#Text.
		#model:.	#model.}! !

!TestingComposableModel class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 1/19/2012 16:43'!
title

	^ 'You should not see me !!'! !

TestCase subclass: #SpecInterpreterTest
	instanceVariableNames: 'specInterpreter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Tests'!

!SpecInterpreterTest commentStamp: '<historical>' prior: 0!
A SpecInterpreterTest is a test class for testing the behavior of SpecInterpreter!

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 16:28'!
setUp
	"Setting up code for SpecInterpreterTest"


	specInterpreter := SpecInterpreter new.! !

!SpecInterpreterTest methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 1/19/2012 15:57'!
tearDown
	"Tearing down code for SpecInterpreterTest"


	specInterpreter := nil.! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:34'!
testBuildMorphFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model.
	
	self assert: (morph model == model).
	self assert: (model morph class = PluggableListMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:35'!
testBuildMorphForWithSpec

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildMorphFor: model withSpec: #testingSpec.
	
	self assert: (morph model == model).
	self assert: (model morph class = PluggableTextMorph).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 17:40'!
testBuildWindowFor

	| model morph |
	model := TestingComposableModel new.
	morph := specInterpreter buildWindowFor: model.
	
	self assert: ( model morph = morph).
	self assert: (morph submorphs anySatisfy: [:e | e class = PluggableListMorph ])! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:34'!
testConvertRandomSymbolOfClassToInstance
	
	| symbol instance |
	symbol := #PluggableListMorph.
	
	instance := specInterpreter convertSymbolOfClassToInstance: symbol.
	self assert: (instance class name = symbol)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 2/4/2012 11:09'!
testConvertSymbolOfClassToInstance
	
	| association instance|
	association := specInterpreter bindings associations first.
	
	instance := specInterpreter convertSymbolOfClassToInstance: association key.
	self assert: (instance class name = association value)! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:03'!
testInterpretASpecModel

	| spec model morph |
	model := ComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (morph model == model).! !

!SpecInterpreterTest methodsFor: 'tests' stamp: 'BenjaminVanRyseghem 1/19/2012 16:28'!
testInterpretASpecModelMorphAssociation

	| spec model morph |
	model := ComposableModel new.
	spec := {#PluggableListMorph. #model:. #model}.
	morph := specInterpreter interpretASpec: spec model: model.
	
	self assert: (model morph == morph).! !
